;===========================================================================================
; Calendrier.asm  Fasm Flat assembler
; Calendrier de Windows
; Programm par AsmGges France
;==========================================================================================

format PE GUI 4.0
entry start

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  include 'win32a.inc'
  include 'macro\if.inc'

;===========================================================================================
; Dbut du code programme
;-------------------------------------------------------------------------------------------
section '.code' code readable executable

 start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,NULL
    mov [hInstance],eax

    ; Assure que la bibliothque de liaison dynamique de contrle commune est charge
    ; -------------------------------------------------------------------------------
    mov [iccex.dwSize],sizeof.INITCOMMONCONTROLSEX
    mov [iccex.dwICC],ICC_DATE_CLASSES
    invoke InitCommonControlsEx,iccex

    ; Cration de la bote de dialogue
    ; --------------------------------
    invoke DialogBoxParam,[hInstance],IDD_DLG,NULL,DialogProc,NULL

    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,0

;===========================================================================================
proc DialogProc uses ebx esi edi, @hDlg , @uMsg , @wParam , @lParam

    .if [@uMsg] = WM_CLOSE
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hDlg],MsgEnd,ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande la fin de l'application
        ; -------------------------------
        invoke EndDialog,[@hDlg],0

    .elseif [@uMsg] = WM_INITDIALOG
        ; Chargement d'une icne
        ; ----------------------
        invoke LoadIcon,[hInstance],IDI_FRANCE

        ; Valider l'icne par Windows
        ; ---------------------------
        invoke SendMessage,[@hDlg],WM_SETICON,ICON_SMALL,eax

    .else
        mov eax,0
        ret

    .endif

    mov eax,1
    ret
endp

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
section '.data' data readable writeable

  ClassName db ' AsmGges Win32',0
  MsgEnd    db ' AsmGges France @2006  ',0
  align 4

  hInstance dd ?

  iccex     INITCOMMONCONTROLSEX

;===========================================================================================
; Inclusion des fichiers .dll contenant les fonctions Windows utilises
;-------------------------------------------------------------------------------------------
section '.idata' import data readable writeable

  library kernel32,'KERNEL32.DLL',\
            user32,'USER32.DLL',\
          comctl32,'COMCTL32.DLL'

  ; Apis Windows dans fichiers dlls
  ; -------------------------------
  include 'apia/kernel32.inc'
  include 'apia/user32.inc'
  include 'apia/comctl32.inc'

;===========================================================================================
; Inclusion des icnes / curseurs / bitmap
;-------------------------------------------------------------------------------------------
section '.rsrc' resource data readable

  directory RT_ICON,icons,\
            RT_GROUP_ICON,group_icons,\
            RT_DIALOG,dialogs

  IDI_FRANCE = 17
  IDD_DLG    = 1000

  resource icons,\
           1,LANG_NEUTRAL,icon_data

  resource group_icons,\
           IDI_FRANCE,LANG_NEUTRAL,main_icon

  resource dialogs,\
           IDD_DLG,LANG_ENGLISH+SUBLANG_DEFAULT,dlg

  dialog dlg,' Calendrier',6,6,136,123,WS_SYSMENU+WS_VISIBLE+DS_CENTER+WS_CAPTION+\
                                                                   WS_MINIMIZEBOX
    dialogitem 'BUTTON','AsmGges Win32',-1,2,2,132,12,WS_VISIBLE+BS_GROUPBOX
    dialogitem 'SysMonthCal32','',-1,2,21,132,98,WS_VISIBLE,WS_EX_CLIENTEDGE

  enddialog

  icon main_icon,icon_data,'res\france.ico'

;===========================================================================================


